TYPE { 
       intlist =  nil or cons( int first, intlist next ); 
       illist  =  nil or cons( intlist first, illist next ); 
       idtree  =  leaf( string id )
               or node( idtree left, idtree right );
}      
